
void ReadSMSC(void)
{
 unsigned char n=0,m=0;
 
 i=0;
 strcpy(uart_rx,"  \n"); 
 uart_puts("at+csca?");
 Delay_ms(5); 
 //uart_gets(); 
 
 while((uart_rx[n]!=0x22)&&(n<100)) n++;
 if(n>=99) {uart_error=1;return;}
 n+=2; 
 while(n<255)
 {
  if(isdigit(uart_rx[n])) {tSMSC[m]=uart_rx[n];}
  if(uart_rx[n]==0x22){return;}
  n++;
  m++;
 }
}

void CodeSMSRus(unsigned char *text)
{
 unsigned char n=strlen(text),k=0,m=0,hh[2];
 
 strcpy(uart_xx,"  \n");
 
 while(k<n)
 {
  if((text[k]>=0x20)&&(text[k]<=0x7f))
  {
   uart_xx[m]='0';
   uart_xx[m+1]='0';
   utoa(hh,text[k],16);
   hh[0]=toupper(hh[0]);
   hh[1]=toupper(hh[1]);
   uart_xx[m+2]=hh[0];
   uart_xx[m+3]=hh[1];
   m+=4;
   k++;
   continue;
  }
  
  if((text[k]>=0xc0)&&(text[k]<=0xff))
  {
   uart_xx[m]='0';
   uart_xx[m+1]='4';
   utoa(hh,text[k]-0xB0,16);
   hh[0]=toupper(hh[0]);
   hh[1]=toupper(hh[1]);
   uart_xx[m+2]=hh[0];
   uart_xx[m+3]=hh[1];
   m+=4;
   k++;
   continue;
  } 
 }
}


void CodeSMS(unsigned char *numer, unsigned char *text)
{
 unsigned char n,m,f=0,kk[2];
 strcpy(uart_tx,"  \n"); 
 n=strlen(numer);
 if(n>9) {n='A'+n-10;}
 else {n+='0';}
 uart_tx[0]='0';
 uart_tx[1]='7';
 uart_tx[2]='9';
 uart_tx[3]='1';
 uart_tx[4]=tSMSC[1];
 uart_tx[5]=tSMSC[0];
 uart_tx[6]=tSMSC[3];
 uart_tx[7]=tSMSC[2];
 uart_tx[8]=tSMSC[5];
 uart_tx[9]=tSMSC[4];
 uart_tx[10]=tSMSC[7];
 uart_tx[11]=tSMSC[6];
 uart_tx[12]=tSMSC[9];
 uart_tx[13]=tSMSC[8];
 uart_tx[14]='F';
 uart_tx[15]=tSMSC[10];
 uart_tx[16]='1';
 uart_tx[17]='1';
 uart_tx[18]='0';
 uart_tx[19]='0';
 uart_tx[20]='0'; 
 uart_tx[21]=n;  
 uart_tx[22]='9';  
 uart_tx[23]='1';
 n=0;
 m=strlen(numer);
 f=24;
 while(n<m)
 {
  uart_tx[f]=numer[n+1];f++;
  uart_tx[f]=numer[n];f++;
  if((m&1)&&(n==m-3))
  {
   uart_tx[f]='F';f++;
   uart_tx[f]=numer[m-1];f++;
   break;
  }
  n+=2;
 }
 uart_tx[f]='0';f++;
 uart_tx[f]='0';f++;
 uart_tx[f]='0';f++;
 uart_tx[f]='8';f++;
 uart_tx[f]='F';f++;
 uart_tx[f]='F';f++; 
 n=strlen(text)*2;
 utoa(kk,n,16);
 if(strlen(kk)<2)
 {
  kk[1]=kk[0];
  kk[0]='0';
 }
 kk[0]=toupper(kk[0]);
 kk[1]=toupper(kk[1]); 
 uart_tx[f]=kk[0];f++;
 uart_tx[f]=kk[1];f++; 
 CodeSMSRus(text);
 n=strlen(uart_xx);
 m=0;
 while(m<n)
 {
  uart_tx[f]=uart_xx[m];f++;
  m++;
 }
 //strcat(uart_tx,SMStext); */
 uart_tx[f]=0x1a;f++;
 uart_tx[f]=0x0d;
}

unsigned char utox(unsigned char *str)
{
 unsigned char ch=0;
 
 str[1]=toupper(str[1]);
 if((str[1]>='0')&&(str[1]<='9')) ch=str[1]-'0';
 if((str[1]>='A')&&(str[1]<='F')) ch=str[1]-'A'+10;
 
 str[0]=toupper(str[0]);
 if((str[0]>='0')&&(str[0]<='9')) ch=ch+(str[0]-'0')*16;
 if((str[0]>='A')&&(str[0]<='F')) ch=ch+(str[0]-'A'+10)*16;
 
 return ch; 
}
