 
#pragma interrupt_handler uart0_rx_isr:12
void uart0_rx_isr(void)
{ 
 rx_bit = UDR;
 
 if((rx_bit>0)&&(i<160))
 {
 
   uart_rx[i]=rx_bit;
   i++;
 
 } 
}


#pragma interrupt_handler uart0_tx_isr:14
void uart0_tx_isr(void)
{
 
}

unsigned char uart_gets(void)
{
 unsigned char m,k=0,l=0; 
 Delay_ms(5); 
 strcpy(uart_xx,"  \n"); 
 k=tx_bit+3; 
 while(1)
 {
  if((uart_rx[k]=='O')&&(uart_rx[k+1]=='K'))
  {   
    if((uart_rx[k+2]==0x0d)&&(uart_rx[k+3]==0x0a))
	{
	 strcpy(uart_xx,"OK");
     return k;   
	}
  }
  
  if((uart_rx[k]=='E')&&(uart_rx[k+1]=='R'))
  {
   if((uart_rx[k+2]=='R')&&(uart_rx[k+3]=='O'))
   {
    if(uart_rx[k+4]=='R') 
	{
	 strcpy(uart_xx,"ERROR");
     return k;
	}
   }
  }
  
  if((k >= i-6))return k;   
  if(uart_rx[k]==0x0d)k++;
  if(uart_rx[k]==0x0a)k++;
  if(uart_rx[k]==0x0d)k++;
  if(uart_rx[k]==0x0a)k++;
  if((k >= i-6))return k; 
  uart_xx[l]=uart_rx[k];  
  l++;
  k++;
 } 
}

void uart_putc(unsigned char data, unsigned int delay)
{ 
 while(!(UCSRA & (1<<UDRE))); 
 UDR = data;
 uart_error=0; 
}

unsigned char uart_puts(unsigned char *str)
{ 
 unsigned char n; 
 strcpy(uart_tx,"  \n"); 
 strcpy(uart_tx,str);
 tx_bit=strlen(str);
 uart_tx[tx_bit]=0x0d;
 for(n=0;(n<=0xff);n++)
 {
  while(!(UCSRA & (1<<UDRE)));
  UDR = uart_tx[n];
  if(uart_tx[n]==0x0d)
  {
   return n+1;  
  } 
 }  
}

unsigned char uart_putss(unsigned char *str)
{ 
 unsigned char n; 
 strcpy(uart_tx,"  \n"); 
 strcpy(uart_tx,str);
 tx_bit=strlen(str);
 uart_tx[tx_bit]=13;
 uart_tx[tx_bit+1]=10;
 for(n=0;(n<=0xff);n++)
 {
  while(!(UCSRA & (1<<UDRE)));
  UDR = uart_tx[n];
  if(uart_tx[n]==10)
  {
   return n+1;  
  } 
 }  
}

unsigned char uart_putsx(void)
{
 unsigned char n; 
 
 for(n=0;n<=0xff;n++)
 {
  while(!(UCSRA & (1<<UDRE)));
  UDR = uart_tx[n];
  if(uart_tx[n]==0x0d)
  {
   return n+1;  
  } 
 } 
 return n;
}